SystemOrganization addCategory: #'Mason-Metacello'!

MDProduct subclass: #MDMetacelloProduct
	instanceVariableNames: 'configuration version required'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Metacello'!

!MDMetacelloProduct methodsFor: 'accessing' stamp: 'cwp 11/10/2009 00:57'!
configuration
	^ configuration! !

!MDMetacelloProduct methodsFor: 'accessing' stamp: 'cwp 11/10/2009 00:57'!
configuration: anObject
	configuration := anObject! !

!MDMetacelloProduct methodsFor: 'specifying' stamp: 'cwp 11/10/2009 00:58'!
packages
	| loader theProject repository packages |
	loader := MetacelloNullRecordingMCSpecLoader new.
	theProject := self project.
	theProject loader: loader.
	theProject load: self required.
	repository := loader loadedRepositories first.
	packages := loader packages.
	packages do: [ :ea | ea repository ifNil: [ ea repository: repository ] ].
	^ packages! !

!MDMetacelloProduct methodsFor: 'specifying' stamp: 'cwp 11/10/2009 00:58'!
project
	^ version 
		ifNil: [ configuration latestVersion ]
		ifNotNil: [ configuration version: version ]! !

!MDMetacelloProduct methodsFor: 'accessing' stamp: 'cwp 10/2/2009 23:57'!
required
	^ required ifNil: [#('DEFAULT')]! !

!MDMetacelloProduct methodsFor: 'accessing' stamp: 'cwp 10/2/2009 23:53'!
required: anObject
	required := anObject! !

!MDMetacelloProduct methodsFor: 'specifying' stamp: 'cwp 11/10/2009 00:12'!
specifyOn: targets 
	| repositories |
	repositories := Dictionary new.
	self packages do: 
		[ :ea | 
		| repository repoSpec |
		repoSpec := ea repository.
		repository := repositories 
			detect: [ :repo | repo name = repoSpec name ]
			ifNone: 
				[ repositories 
					at: repoSpec name
					put: repoSpec createRepository ].
		targets version
			name: ea file, '.mcz'
			repository: repository]! !

!MDMetacelloProduct methodsFor: 'accessing' stamp: 'cwp 10/2/2009 23:53'!
version
	^ version! !

!MDMetacelloProduct methodsFor: 'accessing' stamp: 'cwp 10/2/2009 23:53'!
version: anObject
	version := anObject! !
